--- view_email.php.orig	2005-03-07 18:36:27.000000000 +0200
+++ view_email.php	2005-03-07 18:37:45.000000000 +0200
@@ -71,5 +71,10 @@
     ));
 }
 
+$charset = Mime_Helper::getCharacterSet($email['seb_full_email']);
+if (!empty($charset)) {
+    Header("Content-Type: text/html; charset=" . $charset);
+}
+
 $tpl->displayTemplate();
 ?>
--- include/class.mime_helper.php.orig	2005-03-07 18:36:27.000000000 +0200
+++ include/class.mime_helper.php	2005-03-07 18:38:02.000000000 +0200
@@ -595,6 +595,28 @@
 
 
     /**
+     * Method used to get charset from raw email.
+     *
+     * @access  public
+     * @param   string $input The full body of the message
+     * @return  string charset extracted from Content-Type header of email.
+     */
+    function getCharacterSet($input)
+    {
+        $structure = Mime_Helper::decode($input, false, false);
+        if (empty($structure)) {
+            return false;
+        }
+
+        $content_type = $structure->headers['content-type'];
+        if (preg_match('/charset\s*=\s*(["\'])?([-\w\d]+)(\1)?;?/i', $content_type, $matches)) {
+            return $matches[2];
+        }
+
+        return false;
+    }
+
+    /**
      * Method used to decode the body of a MIME encoded message.
      *
      * @access  public
